"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cli_1 = require("@yarnpkg/cli");
const core_1 = require("@yarnpkg/core");
const clipanion_1 = require("clipanion");
const Constraints_1 = require("../../Constraints");
// eslint-disable-next-line arca/no-default-export
class ConstraintsSourceCommand extends cli_1.BaseCommand {
    constructor() {
        super(...arguments);
        this.verbose = false;
    }
    async execute() {
        const configuration = await core_1.Configuration.find(this.context.cwd, this.context.plugins);
        const { project } = await core_1.Project.find(configuration, this.context.cwd);
        const constraints = await Constraints_1.Constraints.find(project);
        this.context.stdout.write(this.verbose ? constraints.fullSource : constraints.source);
    }
}
ConstraintsSourceCommand.usage = clipanion_1.Command.Usage({
    category: `Constraints-related commands`,
    description: `print the source code for the constraints`,
    details: `
      This command will print the Prolog source code used by the constraints engine. Adding the \`-v,--verbose\` flag will print the *full* source code, including the fact database automatically compiled from your workspaces manifests.
    `,
    examples: [[
            `Prints the source code`,
            `yarn constraints source`,
        ], [
            `Print the source code and the fact database`,
            `yarn constraints source -v`,
        ]],
});
__decorate([
    clipanion_1.Command.Boolean(`-v,--verbose`)
], ConstraintsSourceCommand.prototype, "verbose", void 0);
__decorate([
    clipanion_1.Command.Path(`constraints`, `source`)
], ConstraintsSourceCommand.prototype, "execute", null);
exports.default = ConstraintsSourceCommand;
